#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_DropGoldCFG.h"
std::auto_ptr<Fish_DropGoldCFG> Fish_DropGoldCFG::msSingleton(nullptr);

int Fish_DropGoldCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_DropGoldCFGData* Fish_DropGoldCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_DropGoldCFGData>& Fish_DropGoldCFG::GetMapData()
{
	return mMapData;
}

void Fish_DropGoldCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_DropGoldCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_DropGoldCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mResPath = element->Attribute("ResPath");
		data.mWidth = element->IntAttribute("Width");
		data.mHeight = element->IntAttribute("Height");
		data.mScale = element->FloatAttribute("Scale");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_DropGoldCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_DropGoldCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_DropGoldCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_DropGoldCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_DropGoldCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "ResType", data.mResType);
		LuaCfgHelper::readString(L, "ResName", data.mResName);
		LuaCfgHelper::readString(L, "ResPath", data.mResPath);
		LuaCfgHelper::readInt(L, "Width", data.mWidth);
		LuaCfgHelper::readInt(L, "Height", data.mHeight);
		LuaCfgHelper::readFloat(L, "Scale", data.mScale);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_DropGoldCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_DropGoldCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_DropGoldCFG* Fish_DropGoldCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_DropGoldCFG());
	}
	return msSingleton.get();
}

void Fish_DropGoldCFG::Release()
{
	msSingleton.reset(nullptr);
}
